//+------------------------------------------------------------------+
//|Stochastic_Env.mq4.mq4
//| leonid553 & co
//| http://www.tradersforum.net.ru/
//+------------------------------------------------------------------+
#property copyright "leonid553 & co"
#property link      "http://www.tradersforum.net.ru/"

//---- input parameters---------

extern int     K_period=19;
extern int     D_period=15;

extern int     K_period_=19;
extern int     D_period_=15;

extern int     Slowing=3;
//------------------------------
extern int     TP=130;
extern int     SL=57;
extern int     TP_sell=130;
extern int     SL_sell=57;

extern double  Lot=0.1;
extern int     Slippage=3;
//--------------------------------
extern bool UseTrailing = true;
extern int lMinProfit = 55;
extern int sMinProfit = 55;
extern int lTrailingStop = 58;
extern int sTrailingStop = 60;
extern int lTrailingStep = 5;
extern int sTrailingStep = 5;
//-------------------
static int prevtime = 0;
int ticket;

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  { 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  if(Time[0] == prevtime) 
       return(0);
   prevtime = Time[0];
//*********************************************************************
double StochK_0=iStochastic(NULL, 0, K_period,D_period,Slowing,MODE_SMA,0,MODE_MAIN, 0);
double StochK_1=iStochastic(NULL, 0, K_period,D_period,Slowing,MODE_SMA,0,MODE_MAIN, 1);
double StochD_0=iStochastic(NULL, 0, K_period,D_period,Slowing,MODE_SMA,0,MODE_SIGNAL, 0);

double _StochK_0=iStochastic(NULL, 0, K_period_,D_period_,Slowing,MODE_SMA,0,MODE_MAIN, 0);
double _StochK_1=iStochastic(NULL, 0, K_period_,D_period_,Slowing,MODE_SMA,0,MODE_MAIN, 1);
double _StochD_0=iStochastic(NULL, 0, K_period_,D_period_,Slowing,MODE_SMA,0,MODE_SIGNAL,0);
 
//=====      =================================================
int Orders=OrdersTotal ();     // -  
if (Orders==0)                 //   
  { 
//---------   ----------------------------
  if   (  /*(Stochastic_1<low_lim)  &&
          (Stochastic_0>low_lim)  &&*/
          (StochK_1<StochD_0)  &&
          (StochK_0>StochD_0)  )
   {
  ticket=OrderSend(Symbol(),0,Lot,Ask,Slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,CLR_NONE);
   if(ticket < 0)  { Sleep(30000); prevtime = Time[1]; }
  if (ticket<0) { Print("   BUY #", GetLastError()); return (0); } 
           
   }
//--------   ------------------------------
  if  ( /*(Stochastic_1>up_lim)  &&
          (Stochastic_0<up_lim)  &&  */
          (_StochK_1>_StochD_0)  &&
          (_StochK_0<_StochD_0)) 
   {       
  ticket=OrderSend(Symbol(),1,Lot,Bid,Slippage,Bid+SL_sell*Point,Bid-TP_sell*Point,NULL,0,0,CLR_NONE);
  if(ticket < 0) { Sleep(30000);  prevtime = Time[1]; }
  if (ticket<0) { Print("   SELL #", GetLastError()); return (0); } 
           
    }  
//------------------------------------------------------------------
  }//if (Orders==0) 
//===============================================================================================
if (UseTrailing) TrailPositions(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
void TrailPositions() 
{
  int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;   

    if (OrderType() == OP_BUY) {
      if (Bid-OrderOpenPrice() > lMinProfit*Point) {
        if (OrderStopLoss() < Bid-(lTrailingStop+lTrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-lTrailingStop*Point, OrderTakeProfit(), 0, Blue);
        }}}
    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-Ask > sMinProfit*Point) {
        if (OrderStopLoss() > Ask+(sTrailingStop+sTrailingStep-1)*Point || OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+sTrailingStop*Point, OrderTakeProfit(), 0, Blue);
        }}}}}